SystemOrganization addCategory: #'UnixMetaStack-Profiling'!

TestCase subclass: #TestExperiment
	instanceVariableNames: 'experiment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:40'!
setUp

	| aSetUp |
	super setUp.
	aSetUp := ProfilingExperimentSetUp new.
	experiment := (self testedClass newWith: (aSetUp evalStringForCategory: aSetUp class greenTrainingCategories first) times: 2) run.! !

!TestExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:53'!
testSanity

	experiment sanityCheck.
	experiment inspect.! !

!TestExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:21'!
testedClass

	^ ExtendedProfileExperiment! !

TestCase subclass: #TestProfilingExperimentSetUp
	instanceVariableNames: 'experiment setUpVanilla setUpProfiling setUpExtendedProfiling vanillaFile profileFile extendedProfileFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 20:50'!
setUp

	setUpVanilla := (ProfilingExperimentSetUp 
						newWith: #testingCategories 
						forExperimentClass: VanillaExperiment 
						withNumberOfRunsPerCategory: 2) run.
	setUpProfiling := (ProfilingExperimentSetUp 
						newWith: #testingCategories 
						forExperimentClass: ProfileExperiment 
						withNumberOfRunsPerCategory: 2) run.
	setUpExtendedProfiling := (ProfilingExperimentSetUp 
									newWith: #testingCategories 
									forExperimentClass: ExtendedProfileExperiment 
									withNumberOfRunsPerCategory: 2) run.
									
	setUpProfiling slowDownFrom: setUpVanilla.
	setUpExtendedProfiling slowDownFrom: setUpVanilla.! !

!TestProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 20:57'!
tearDown

	(FileSystem workingDirectory / vanillaFile) delete.
	(FileSystem workingDirectory / profileFile) delete.
	(FileSystem workingDirectory / extendedProfileFile) delete.! !

!TestProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 20:52'!
testExportImportSanity

	
	vanillaFile := setUpVanilla exportToFuel.
	profileFile := setUpProfiling exportToFuel.
	extendedProfileFile := setUpExtendedProfiling exportToFuel.
	
	setUpVanilla := ProfilingExperimentSetUp importFromFuelFileName: vanillaFile.
	profileFile := ProfilingExperimentSetUp importFromFuelFileName: profileFile.
	extendedProfileFile := setUpExtendedProfiling importFromFuelFileName: extendedProfileFile.
	
	self testSanity.
	
	! !

!TestProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 20:45'!
testSanity

	setUpVanilla sanityCheck.
	setUpProfiling sanityCheck.
	setUpExtendedProfiling sanityCheck.! !

TestCase subclass: #TestRun
	instanceVariableNames: 'run failedRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:32'!
setUp

	run := (self testedClass newWith: '3+4') run.
	failedRun := (self testedClass newWith: '#@$@#%@') run.! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:30'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:44'!
testOSProcessOutput
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (run instVarNamed: 'rawOutput') = '7
'! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 20:37'!
testSanity

	run sanityCheck.! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:39'!
testedClass

	^ Run
! !

TestRun subclass: #TestVanillaExperimentRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

TestVanillaExperimentRun subclass: #TestProfileExperimentRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

TestProfileExperimentRun subclass: #TestExtendedProfileExperimentRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 12:02'!
setUp

	| aSetUp |
	super setUp.
	aSetUp := ProfilingExperimentSetUp new.
	run := (self testedClass newWith: (aSetUp evalStringForCategory: aSetUp class greenTrainingCategories first)) run.! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:58'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:18'!
testOSProcessOutput
	
	self assert: ((run instVarNamed: 'rawOutput') isKindOf: String).! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 14:09'!
testParsing
		
	super testParsing.
	self assert: ((run instVarNamed: 'byteCodes') isKindOf: Array). 
	self assert: ((run instVarNamed: 'slowPrimitives') isKindOf: Array). 
	self assert: ((run instVarNamed: 'quickPrimitives') isKindOf: Array).
	self assert: ((run instVarNamed: 'qPrimitiveCounter') isKindOf: Number).! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 19:58'!
testSanity

	super testSanity.
	run inspect.! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:17'!
testedClass

	^ ExtendedProfileExperimentRun! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:57'!
setUp

	super setUp! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:57'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:57'!
testOSProcessOutput
	
	self assert: ((run instVarNamed: 'rawOutput') isKindOf: String).! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:22'!
testParsing
		
	super testParsing.
	self assert: ((run instVarNamed: 'byteCodeCounter') isKindOf: Number). 
	self assert: ((run instVarNamed: 'messageCounter') isKindOf: Number). 
	self assert: ((run instVarNamed: 'primitiveCounter') isKindOf: Number).! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:58'!
testSanity

	super testSanity! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 10:08'!
testedClass

	^ ProfileExperimentRun! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:56'!
setUp

	super setUp! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:55'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 22:08'!
testOSProcessOutput
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (run instVarNamed: 'rawOutput') = '7
'! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 22:09'!
testParsing

	self assert: ((run instVarNamed: 'realTime') isKindOf: Number). 
	self assert: ((run instVarNamed: 'userTime') isKindOf: Number). 
	self assert: ((run instVarNamed: 'systemTime') isKindOf: Number). ! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:56'!
testSanity

	super testSanity! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 10:08'!
testedClass

	^ VanillaExperimentRun! !

StackInterpreterPrimitives subclass: #ProfileStackInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ProfileStackInterpreter subclass: #ExtendedProfileStackInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/12/2014 14:37'!
fetchNextBytecode

	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."
	
	"bytecode counters -- for analysis see p. 595 of blue book and StackInterpreter>>initializeBytecodeTableForSqueakV3PlusClosures"
	self incByteCodeCounter.
	self cppIf: MULTIPLEBYTECODESETS
		ifTrue: [currentBytecode := self fetchByte + bytecodeSetSelector]
		ifFalse: [currentBytecode := self fetchByte].! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/12/2014 14:37'!
incByteCodeCounter

	<api>
	self cCode: 'bCounter++;bArrayCounter[getCurrentBytecode()]++;'! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 18:19'!
internalExecuteNewMethod
	"regardless of whether it succeeded or not count it since it is executed"
	"for primitive Stats check StackInterpreter>>initializePrimitiveTable and StackInterpreter>>functionPointerFor: primIdx inClass: theClass"
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~= 0 ifTrue:
		[self incPrimitiveCounter.
		 self isPrimitiveFunctionPointerAnIndex ifTrue:
			[self profileQuickPrimitive. ^self internalQuickPrimitiveResponse].
		 self profileSlowPrimitive.
		 self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:16'!
printProfilingResults

	<api>
	self cCode: 'unsigned int i;'.
	self cCode: 'printf("__VM_STATS__START__{ \
	#byteCodeCounter ->%llu. \
	#messageCounter -> %llu. \
	#primitiveCounter -> %llu. \
	#qPrimitiveCounter -> %llu. \
	#sPrimitiveCounter -> %llu. \
	#otherPrimitiveCounter -> %llu. \
	#byteCode -> #( \
	",bCounter,mCounter,pCounter,qPrimitiveCounter,sPrimitiveCounter,otherPrimitiveCounter);'.
	self cCode: 'for(i=0;i<256;i++) printf("%llu\n",bArrayCounter[i])'.
	self  cCode: 'printf("). \
	#quickPrimitive -> #( \
	");'.
	self cCode: 'for(i=0;i<520;i++) printf("%llu\n",quickPrimitiveCounter[i])'.
	self cCode: 'printf("). \
	#slowPrimitive -> #( \
	");'.
	self cCode: 'for(i=0;i<576;i++) printf("%llu\n",slowPrimitiveCounter[i])'.
	self cCode: 'printf("). \
	}.__VM_STATS__END__ \
	");'.! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 14:00'!
profileQuickPrimitive

	<api>
	|index|
	index := (self cCoerce: primitiveFunctionPointer to: #sqInt). "check bounds for coercion ?"
	self cCode: 'qPrimitiveCounter++;'. "check if naming persists in translation"
	self cCode: 'quickPrimitiveCounter[index]++;'. "check if naming persists in translation"! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 20:14'!
profileSlowPrimitive

	"check dispatchFunctionPointer: aFunctionPointer"

	<api>
	|index|
	index := -1.
	0 to: MaxPrimitiveIndex do: [ :i | ((primitiveTable at: i) == primitiveFunctionPointer ifTrue: [ index := i ]).].
	self cCode: 'if(index==-1) otherPrimitiveCounter++; else {sPrimitiveCounter++;slowPrimitiveCounter[index]++;};'.! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:21'!
commonSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	<sharedCodeNamed: 'commonSend' inCase: #singleExtendedSendBytecode>
	self incMessageCounter.
	super commonSend.! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:21'!
fetchNextBytecode
	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."
	
	self incByteCodeCounter.
	self cppIf: MULTIPLEBYTECODESETS
		ifTrue: [currentBytecode := self fetchByte + bytecodeSetSelector]
		ifFalse: [currentBytecode := self fetchByte]! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:20'!
incByteCodeCounter

	<api>
	self cCode: 'bCounter++;'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:20'!
incMessageCounter
	<api>
	self cCode: 'mCounter++;'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:20'!
incPrimitiveCounter
	<api>
	self cCode: 'pCounter++;'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:19'!
internalExecuteNewMethod
	"regardless of whether it succeeded or not count it since it is executed"
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~= 0 ifTrue:
		[self incPrimitiveCounter.self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		 self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:22'!
primitiveQuit
	self printProfilingResults.
	super primitiveQuit.! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:08'!
print: s
	"For testing in Smalltalk, this method should be overridden in a subclass."
	<api>
	<var: #s type: #'char *'>
	self cCode: 'fputs(s, stdout)'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/12/2014 13:57'!
printProfilingResults
	<api>
	self cCode: 'printf("__VM_STATS__START__{ \
	#byteCodeCounter ->%llu. \
	#messageCounter -> %llu. \
	#primitiveCounter -> %llu. }.__VM_STATS__END__ \
	",bCounter,mCounter,pCounter);'.
	! !

StackUnixConfig subclass: #ProfileUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ProfileUnixConfig subclass: #ExtendedProfileUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:23'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#include <stdint.h>
uint64_t bCounter;
uint64_t mCounter;
uint64_t pCounter;

uint64_t qPrimitiveCounter; /*sanity-check*/
uint64_t sPrimitiveCounter; /*sanity-check*/
uint64_t otherPrimitiveCounter; /*external, named e.t.c*/
uint64_t bArrayCounter[256];
uint64_t quickPrimitiveCounter[520];
uint64_t slowPrimitiveCounter[576];

/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!ExtendedProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:11'!
executableName
	^ 'ExtendedProfileStackVM'! !

!ExtendedProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:11'!
interpreterClass
	^ ExtendedProfileStackInterpreter! !

!ProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:07'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#include <stdint.h>
uint64_t bCounter;
uint64_t mCounter;
uint64_t pCounter;

/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!ProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:07'!
executableName
	^ 'ProfileStackVM'! !

!ProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:07'!
interpreterClass
	^ ProfileStackInterpreter! !

StackUnixDebugConfig subclass: #ProfileUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ProfileUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:25'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#include <stdint.h>
uint64_t bCounter;
uint64_t mCounter;
uint64_t pCounter;

/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!ProfileUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:07'!
executableName
	^ 'ProfileStackDebugVM'! !

!ProfileUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:06'!
interpreterClass
	^ ProfileStackInterpreter! !

Object subclass: #Experiment
	instanceVariableNames: 'runs evalString numberOfRuns averageAndStDevRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!Experiment class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:07'!
newWith: aString times: numberOfRuns

	^ self new
		evalString: aString;
		times: numberOfRuns.! !

!Experiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/17/2014 20:43'!
averageAndStDevRun
	^ averageAndStDevRun! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 13:58'!
calculateAverageAndStDevRun

	|any numericIvs stDevDict|
	averageAndStDevRun := self runClass new.
	stDevDict := Dictionary new.
	averageAndStDevRun instVarNamed: 'stDevDict' put: stDevDict.
	averageAndStDevRun instVarNamed: 'executedSuccessfully' put: true.
	any := runs anyOne.
	numericIvs := self runClass allInstVarNames select: [ :iv | (any instVarNamed: iv asString) isKindOf: Number ].
	numericIvs do: [ :iv | |ivInRuns|
		ivInRuns := (runs collect: [:run | run instVarNamed: iv]). 
		averageAndStDevRun
			instVarNamed: iv 
			put:  ivInRuns average.
		stDevDict at: iv put: ivInRuns stdev. 
	].! !

!Experiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:47'!
evalString
	^ evalString! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:23'!
evalString: aString

	evalString := aString! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:21'!
initialize

	super initialize.
	runs := OrderedCollection new.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 20:53'!
run

	(1 to: numberOfRuns) do:  [ :i |
		runs add: (self runClass newWith: evalString) run.
	 ].
	self calculateAverageAndStDevRun.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:53'!
runClass

	self subclassResponsibility ! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:17'!
sanityCheck

	runs do:  [ :each | each sanityCheck ].
	averageAndStDevRun sanityCheck.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:08'!
times: aNumber

	numberOfRuns := aNumber! !

Experiment subclass: #VanillaExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

VanillaExperiment subclass: #ProfileExperiment
	instanceVariableNames: 'slowDownInSeconds slowDownX slowDownPercentage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ProfileExperiment subclass: #ExtendedProfileExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:16'!
runClass

	^ ExtendedProfileExperimentRun ! !

!ProfileExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:16'!
runClass

	^ ProfileExperimentRun! !

!ProfileExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 11:50'!
slowDownFrom: aVanillaExperiment

	self assert: (aVanillaExperiment class = VanillaExperiment).
	self assert: (aVanillaExperiment evalString = evalString).
	slowDownInSeconds := averageAndStDevRun realTime - aVanillaExperiment averageAndStDevRun realTime.
	slowDownX := averageAndStDevRun realTime / aVanillaExperiment averageAndStDevRun realTime.
	slowDownPercentage := slowDownInSeconds / aVanillaExperiment averageAndStDevRun realTime.! !

!ProfileExperiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 12:13'!
slowDownInSeconds
	^ slowDownInSeconds! !

!ProfileExperiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 12:14'!
slowDownPercentage
	^ slowDownPercentage! !

!ProfileExperiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 12:14'!
slowDownX
	^ slowDownX! !

!VanillaExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:15'!
runClass

	^ VanillaExperimentRun! !

Object subclass: #ProfilingExperimentSetUp
	instanceVariableNames: 'categories experimentClass numberOfRunsForEachCategory experiments selector slowDownInSeconds slowDownX slowDownPercentage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:00'!
allPredictionCategories! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:00'!
allTrainingCategories

	"generated by running calculateAllTrainingCategories in target image -- here is Pharo-2.0"

	^  #(#'AST-Tests-Core' #'AST-Tests-Semantic' #AndreasProfiler #'Announcements-Tests-Core' #'Balloon-Fills-Tests' #'BalloonTests-Collections' #'CollectionsTests-Abstract' #'CollectionsTests-Arrayed' #'CollectionsTests-Atomic' #'CollectionsTests-Sequenceable' #'CollectionsTests-SplitJoin' #'CollectionsTests-Stack' #'CollectionsTests-Streams' #'CollectionsTests-Strings' #'CollectionsTests-Support' #'CollectionsTests-Unordered' #'CollectionsTests-Weak' #CompilerTests #'CompressionTests-Archive' #'ConfigurationCommandLineHandler-Tests' #'FileSystem-Tests-Core' #'FileSystem-Tests-Disk' #'FileSystem-Tests-Memory' #'FreeTypeTests-cache' #FuelTests #'FuelTests-Collections' #'FuelTests-Streams' #'Gofer-Tests' #'Graphics-Tests-Files' #'Graphics-Tests-Primitives' #'HelpSystem-Tests-Builders' #'HelpSystem-Tests-Core-Model' #'HelpSystem-Tests-Core-UI' #'HelpSystem-Tests-Core-Utilities' #'KernelTests-Chronology' #'KernelTests-Classes' #'KernelTests-Exception' #'KernelTests-Methods' #'KernelTests-Numbers' #'KernelTests-Objects' #'KernelTests-Pragmas' #'KernelTests-Processes' #'Keymapping-Tests' #'Manifest-Tests' #'MorphicTests-Basic' #'MorphicTests-Event' #'MorphicTests-Kernel' #'MorphicTests-Layouts' #'MorphicTests-Text Support' #'MorphicTests-Widgets' #'MorphicTests-WindowNotification' #'Multilingual-Tests-TextConversion' #'NECompletion-Tests' #'NECompletion-View-Tests' #'Nautilus-Tests' #'NetworkTests-Kernel' #'NetworkTests-Mail' #'NetworkTests-Protocols' #'NetworkTests-RFC822' #'NetworkTests-URI' #'NetworkTests-UUID' #'NetworkTests-Url' #'RPackage-SystemIntegration' #'RPackage-Tests' #'Refactoring-Tests-Changes' #'Refactoring-Tests-Core' #'Refactoring-Tests-Critics' #'Refactoring-Tests-Environment' #'Regex-Tests-Core' #'Ring-Tests-Containers' #'Ring-Tests-Kernel' #'Ring-Tests-Monticello' #'SUnit-Core-Extensions' #'SUnit-Core-Kernel' #'SUnit-Core-Utilities' #'SUnit-Tests-Core' #'SUnit-UITesting' #'ShoutTests-Parsing' #'ShoutTests-Styling' #'Spec-Tests' #'Spec-Tools-Senders-Tests' #'Tests-Bugs' #'Tests-CodeImport' #'Tests-Compression' #'Tests-Digital Signatures' #'Tests-Exceptions' #'Tests-Files' #'Tests-Finalization' #'Tests-Monticello' #'Tests-Multilingual' #'Tests-Object Events' #'Tests-ObjectsAsMethods' #'Tests-PackageInfo' #'Tests-Polymorph-Widgets' #'Tests-Release' #'Tests-ScriptLoader' #'Tests-System' #'Tests-System-CommandLine' #'Tests-SystemChangeNotification' #'Tests-SystemHistory' #'Tests-SystemTests-Support' #'Tests-TextEditors' #'Tests-Traits' #'Tests-Traits-MOP' #'Tests-VM' #TextTests #'ToolsTest-Base' #'ToolsTest-Debugger' #'ToolsTest-Finder' #'ToolsTest-Inspector' #'ToolsTest-MessageTally' #'ToolsTest-PointerFinder' #'UpdateStreamer-Tests' #'Zinc-Character-Encoding-Tests' #'Zinc-Resource-Meta-FileSystem' #'Zinc-Resource-Meta-Tests' #'Zinc-Tests' #'Zinc-Zodiac' #'Zodiac-Tests' #'ProfStef-Tests')! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:00'!
calculateAllTrainingCategories

	^ TestRunner new categoryList.
! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:00'!
calculateGreenTrainingCategories

	| allCategories greenCategories |
	allCategories := TestRunner new categoryList.
	greenCategories := OrderedCollection new.

	allCategories do: [ :category | |tr|
		tr := TestRunner new.
		tr categoryAt: (allCategories indexOf: category) put: true; "etc"
		selectAllClasses;
		runAll.		
		(tr result defects isEmpty) ifTrue: [ greenCategories add: category ]
	].

	^ greenCategories asArray.! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:00'!
greenPredictionCategories! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:00'!
greenTrainingCategories

	"generated by running calculateGreenTrainingCategories in target image -- here Pharo 2.0"
	
	^  #(#'AST-Tests-Core' #'AST-Tests-Semantic' #AndreasProfiler #'Announcements-Tests-Core' #'Balloon-Fills-Tests' #'BalloonTests-Collections' #'CollectionsTests-Abstract' #'CollectionsTests-Arrayed' #'CollectionsTests-Atomic' #'CollectionsTests-Sequenceable' #'CollectionsTests-SplitJoin' #'CollectionsTests-Stack' #'CollectionsTests-Streams' #'CollectionsTests-Strings' #'CollectionsTests-Support' #'CollectionsTests-Unordered' #'CollectionsTests-Weak' #CompilerTests #'CompressionTests-Archive' #'ConfigurationCommandLineHandler-Tests' #'FileSystem-Tests-Core' #'FileSystem-Tests-Memory' #'FreeTypeTests-cache' #FuelTests #'FuelTests-Collections' #'FuelTests-Streams' #'Gofer-Tests' #'Graphics-Tests-Files' #'Graphics-Tests-Primitives' #'HelpSystem-Tests-Builders' #'HelpSystem-Tests-Core-Model' #'HelpSystem-Tests-Core-UI' #'HelpSystem-Tests-Core-Utilities' #'KernelTests-Chronology' #'KernelTests-Classes' #'KernelTests-Exception' #'KernelTests-Methods' #'KernelTests-Numbers' #'KernelTests-Objects' #'KernelTests-Pragmas' #'KernelTests-Processes' #'Keymapping-Tests' #'Manifest-Tests' #'MorphicTests-Basic' #'MorphicTests-Event' #'MorphicTests-Kernel' #'MorphicTests-Layouts' #'MorphicTests-Text Support' #'MorphicTests-Widgets' #'MorphicTests-WindowNotification' #'Multilingual-Tests-TextConversion' #'NECompletion-Tests' #'NECompletion-View-Tests' #'Nautilus-Tests' #'NetworkTests-Kernel' #'NetworkTests-Mail' #'NetworkTests-Protocols' #'NetworkTests-RFC822' #'NetworkTests-URI' #'NetworkTests-UUID' #'NetworkTests-Url' #'RPackage-SystemIntegration' #'Refactoring-Tests-Changes' #'Refactoring-Tests-Core' #'Refactoring-Tests-Critics' #'Refactoring-Tests-Environment' #'Regex-Tests-Core' #'Ring-Tests-Containers' #'Ring-Tests-Kernel' #'Ring-Tests-Monticello' #'SUnit-Core-Extensions' #'SUnit-Core-Kernel' #'SUnit-Core-Utilities' #'SUnit-Tests-Core' #'ShoutTests-Parsing' #'ShoutTests-Styling' #'Spec-Tests' #'Spec-Tools-Senders-Tests' #'Tests-Bugs' #'Tests-CodeImport' #'Tests-Compression' #'Tests-Digital Signatures' #'Tests-Exceptions' #'Tests-Files' #'Tests-Finalization' #'Tests-Monticello' #'Tests-Multilingual' #'Tests-Object Events' #'Tests-ObjectsAsMethods' #'Tests-PackageInfo' #'Tests-Polymorph-Widgets' #'Tests-Release' #'Tests-ScriptLoader' #'Tests-System' #'Tests-System-CommandLine' #'Tests-SystemChangeNotification' #'Tests-SystemHistory' #'Tests-SystemTests-Support' #'Tests-TextEditors' #'Tests-Traits' #'Tests-Traits-MOP' #'Tests-VM' #TextTests #'ToolsTest-Base' #'ToolsTest-Debugger' #'ToolsTest-Finder' #'ToolsTest-Inspector' #'ToolsTest-MessageTally' #'ToolsTest-PointerFinder' #'UpdateStreamer-Tests' #'Zinc-Character-Encoding-Tests' #'Zinc-Resource-Meta-FileSystem' #'Zinc-Resource-Meta-Tests' #'Zinc-Zodiac' #'ProfStef-Tests')! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 16:05'!
importFromFuelFileName: aFileName

	^ FLMaterializer materializeFromFileNamed: aFileName.! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 18:57'!
newWith: categoriesSelector forExperimentClass: anExperimentClass withNumberOfRunsPerCategory: numberOfRuns

	self new
		initializeWith: categoriesSelector
		forExperimentClass: anExperimentClass
		withNumberOfRunsPerCategory: numberOfRuns.! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 15:50'!
testCategories

	
	^  #(#'AST-Tests-Core' #'AST-Tests-Semantic')! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:24'!
evalStringForCategory: aCategory
	
	^ 'TestRunner new categoryAt: (TestRunner new categoryList indexOf:' , aCategory printString , ') put: true; selectAllClasses; runAll.'.		! !

!ProfilingExperimentSetUp methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:53'!
experimentClass
	^ experimentClass! !

!ProfilingExperimentSetUp methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:52'!
experiments
	^ experiments! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 15:56'!
exportToFuel

	|filename|
	filename := 'ProfilingExperimentSetup' , '_' , experimentClass printString , '_' , DateAndTime now printString , '.experiment'.
	FLSerializer serialize: self toFileNamed: filename.
	^ filename
! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 16:01'!
exportToOctave! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:20'!
initializeWith: categoriesSelector forExperimentClass: anExperimentClass withNumberOfRunsPerCategory: numberOfRuns

	selector := categoriesSelector.
	categories := self class perform: categoriesSelector. 
	experimentClass := anExperimentClass.  
	numberOfRunsForEachCategory := numberOfRuns.
	experiments := OrderedCollection new.! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:17'!
run

	categories do: [ :category | 
		experiments
			add: (experimentClass 
					newWith: (self evalStringForCategory: category) 
					times: numberOfRunsForEachCategory;
					run).
	].  
		 
		! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 20:46'!
sanityCheck
		
	experiments do: [ :experiment | experiment sanityCheck ]! !

!ProfilingExperimentSetUp methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:55'!
selector
	^ selector! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 12:13'!
slowDownFrom: anExperimentalSetUp

	|vanillaExperiments|
	
	vanillaExperiments := anExperimentalSetUp experiments.
	
	self assert: (anExperimentalSetUp experimentClass = VanillaExperiment).
	self assert: (anExperimentalSetUp selector) = selector.
	self assert: (vanillaExperiments size = experiments size).
	
	slowDownInSeconds := experiments withIndexCollect: [ :experiment :index | experiment slowDownFrom: (vanillaExperiments at: index). experiment slowDownInSeconds ].
	slowDownX := experiments withIndexCollect: [ :experiment :index | experiment slowDownX ].
	slowDownPercentage := experiments withIndexCollect: [ :experiment :index | experiment slowDownPercentage ].
	
	slowDownInSeconds := (slowDownInSeconds average -> slowDownInSeconds stdev).
	slowDownX := (slowDownX average -> slowDownX stdev).
	slowDownPercentage := (slowDownPercentage average -> slowDownPercentage stdev).! !

Object subclass: #Run
	instanceVariableNames: 'evalString rawOutput rawTimeOutput executedSuccessfully stDevDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!Run class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:20'!
newWith: aString

	^ self new
		evalString: aString! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:14'!
clearStats

	(FileSystem workingDirectory / 'output') exists ifTrue: [ (FileSystem workingDirectory / 'output') delete ].
	(FileSystem workingDirectory / 'timeOutput') exists ifTrue: [ (FileSystem workingDirectory / 'timeOutput') delete ].
	! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:19'!
evalString: aString

	evalString := aString! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:39'!
parseOutput
! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 20:21'!
path

	^ '/home/art/Desktop/june/mStackVM/sources/results/'! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 15:02'!
postProcessing! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 15:03'!
run

	"check also /usr/bin/time -- has more stats -- its the default if you dont invoke bash"

	| rStream |
	self clearStats.
	OSProcess waitForCommand: 'time -p -o timeOutput ' , self path , self vm , ' -vm-display-X11 -headless ' , self path, self targetImage , ' eval "' , evalString , '" > output'.
	rStream := (FileSystem workingDirectory / 'output') readStream.
	rawOutput  := rStream contents.
	rStream close.
	rStream := (FileSystem workingDirectory / 'timeOutput') readStream.
	rawTimeOutput  := rStream contents.
	rStream close.
	(rawTimeOutput findString: 'non-zero') ~= 0 ifTrue: [ executedSuccessfully := false ] ifFalse: [ executedSuccessfully := true ].
	self clearStats.
	executedSuccessfully ifTrue: [self parseOutput. self postProcessing]. "sanity checks better left afterwards"! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 15:05'!
sanityCheck

	"collect assertion with an on:do: from client code -- use also in tests"
	
	self assert: executedSuccessfully 
! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:54'!
targetImage

	^ 'Pharo-20628.image'! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:40'!
vm

	^ 'StackVM'! !

Run subclass: #VanillaExperimentRun
	instanceVariableNames: 'realTime userTime systemTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

VanillaExperimentRun subclass: #ProfileExperimentRun
	instanceVariableNames: 'byteCodeCounter messageCounter primitiveCounter statsDict byteCodesPerSecond primitivesPerSecond messagesPerSecond'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ProfileExperimentRun subclass: #ExtendedProfileExperimentRun
	instanceVariableNames: 'byteCodes quickPrimitives slowPrimitives qPrimitiveCounter otherPrimitiveCounter byteCodeSum quickPrimitiveSum slowPrimitiveSum stackByteCodeSum returnByteCodeSum sendByteCodeSum jumpByteCodeSum stackRatio returnRatio sendRatio jumpRatio primitiveRatioToMessages primitiveRatioToByteCode quickRatioToPrimitives slowRatioToPrimitives otherRatioToPrimitives sPrimitiveCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:17'!
parseOutput

	super parseOutput. "gathers time output and statsDict"
	byteCodes := statsDict at: #byteCode.
	quickPrimitives := statsDict at: #quickPrimitive.
	slowPrimitives := statsDict at: #slowPrimitive.
	qPrimitiveCounter := statsDict at: #qPrimitiveCounter.
	sPrimitiveCounter := statsDict at: #sPrimitiveCounter.
	otherPrimitiveCounter := statsDict at: #otherPrimitiveCounter.! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 20:04'!
postProcessing

	super postProcessing.

	byteCodeSum := byteCodes sum: [:each | each].
	quickPrimitiveSum := quickPrimitives sum: [:each | each].
	slowPrimitiveSum := slowPrimitives sum: [:each | each].
	stackByteCodeSum := 
		((byteCodes collect: [:each | each] from: 1 to: 120) ,  
		(byteCodes collect: [:each | each] from: 129 to: 131) , 
		(byteCodes collect: [:each | each] from: 136 to: 144)) sum: [ :each | each ].
	returnByteCodeSum := ((byteCodes collect: [:each | each] from: 121 to: 128)) sum: [ :each | each ].
	sendByteCodeSum := 
		((byteCodes collect: [:each | each] from: 132 to: 135) ,  
			(byteCodes collect: [:each | each] from: 177 to: 256)) sum: [ :each | each ].
	jumpByteCodeSum := ((byteCodes collect: [:each | each] from: 145 to: 176)) sum: [ :each | each ].
	returnRatio := returnByteCodeSum / byteCodeSum.
	sendRatio := sendByteCodeSum / byteCodeSum.
	jumpRatio := jumpByteCodeSum / byteCodeSum.
	stackRatio := stackByteCodeSum / byteCodeSum.
	primitiveRatioToMessages := primitiveCounter / messageCounter.
	primitiveRatioToByteCode := primitiveCounter / byteCodeCounter.
	quickRatioToPrimitives := quickPrimitiveSum / primitiveCounter.
	slowRatioToPrimitives := slowPrimitiveSum / primitiveCounter.
	otherRatioToPrimitives := otherPrimitiveCounter / primitiveCounter.! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:59'!
sanityCheck

	super sanityCheck.
	self assert: (byteCodeCounter = byteCodeSum).
	self assert: (qPrimitiveCounter = quickPrimitiveSum).
	self assert: (sPrimitiveCounter = slowPrimitiveSum).
	self assert: (primitiveCounter = (quickPrimitiveSum + slowPrimitiveSum + otherPrimitiveCounter)).
	self assert: (byteCodeCounter = (stackByteCodeSum + returnByteCodeSum + sendByteCodeSum + jumpByteCodeSum)).
	self assert: (messageCounter <= sendByteCodeSum). "because of bytecodePrim sends which will either be executed inline
	or send a normal send depending on arguments"! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:47'!
vm

	^ 'ExtendedProfileStackVM'! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 10:04'!
parseOutput

	super parseOutput. "gathers time output"
	statsDict := (Compiler evaluate: ((rawOutput findBetweenSubStrs: { '__VM_STATS__START__' . '__VM_STATS__END__' }) at: 2)) asDictionary.
	byteCodeCounter := statsDict at: #byteCodeCounter.
	messageCounter := statsDict at: #messageCounter.
	primitiveCounter := statsDict at: #primitiveCounter.! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 20:22'!
postProcessing

	super postProcessing.
	byteCodesPerSecond := byteCodeCounter / realTime.
 	primitivesPerSecond := primitiveCounter / realTime.
	messagesPerSecond := messageCounter / realTime.! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 20:31'!
sanityCheck

	super sanityCheck.
	self assert: (byteCodeCounter > messageCounter).
	self assert: (messageCounter > primitiveCounter).! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:46'!
vm

	^ 'ProfileStackVM'! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 21:57'!
parseOutput

	"in seconds"
	
	| timeOutputParsed |
	timeOutputParsed := (rawTimeOutput findBetweenSubStrs: {'real' . 'user' . 'sys'}) collect: [ :str | str trim asNumber ].
	realTime := timeOutputParsed at: 1.
	userTime := timeOutputParsed at: 2.
	systemTime := timeOutputParsed at: 3.
	! !

!VanillaExperimentRun methodsFor: 'accessing' stamp: 'NickPapoulias 6/17/2014 20:45'!
realTime
	^ realTime! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 22:10'!
sanityCheck

	super sanityCheck.
	self assert: (realTime >= (userTime + systemTime)).! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:43'!
vm

	^ 'StackVM'! !
